#!/bin/bash

set -e

tmp=$(mktemp -d)

trap cleanup EXIT
cleanup() {
	set +e
	[ -z "$tmp" -o ! -d "$tmp" ] || rm -rf "$tmp"
}

unset CDPATH
pwd=$(pwd)
git=$(date +%Y%m%d)

cd "$tmp"
git-clone git://w1.fi/srv/git/hostap.git
find hostap -type d -name .gitignore -print0 | xargs -0r rm -rf
mv hostap/hostapd hostapd-git-$git
mv hostap/wpa_supplicant wpa_supplicant-git-$git
mv hostap/patches "$pwd"/patches-hostap-$git
tar jcf "$pwd"/hostapd-git-$git.tar.bz2 hostapd-git-$git
tar jcf "$pwd"/wpa_supplicant-git-$git.tar.bz2 wpa_supplicant-git-$git
cd - >/dev/null

