%define date 2007-03-25
%define madwifi_version 0.9.3
%define mac80211_version 6.0.0
%define wpa_supplicant_version 0.6-2007-03-25

Name:           hostapd
Version:        0.6
Release:        0.5.%(echo %{date} |sed 's|-||g')%{?dist}
Summary:        User space daemon for access point

%define _version %{version}-%{date}
#define _version %{version}
#define _version git-%{date}

Group:          System Environment/Daemons
License:        GPL
URL:            http://hostap.epitest.fi/hostapd/
Source0:        http://hostap.epitest.fi/releases/snapshots/hostapd-%{_version}.tar.gz
#Source0:	http://hostap.epitest.fi/releases/hostapd-%{_version}.tar.gz
#Source0:        hostapd-git-%{date}.tar.bz2
Source1:        http://belnet.dl.sourceforge.net/sourceforge/madwifi/madwifi-%{madwifi_version}.tar.bz2 
Source2:	http://intellinuxwireless.org/mac80211/downloads/mac80211-%{mac80211_version}.tgz
Source3:	http://hostap.epitest.fi/releases/snapshots/wpa_supplicant-%{wpa_supplicant_version}.tar.gz
#Source3:	wpa_supplicant-git-%{date}.tar.bz2
Patch0:         http://kwizart.free.fr/fedora/patches/hostapd-0.6-Base_config.patch
Source10:       hostap-snapshot.sh
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:  libdhcp-devel
BuildRequires:  openssl-devel
BuildRequires:  krb5-devel
BuildRequires:  zlib-devel
BuildRequires:  kernel-devel >= 2.6.20
BuildRequires:  kernel-headers
#BuildRequires:  madwifi-devel
Requires:       logwatch
 

%description
hostapd is a user space daemon for access point and authentication servers.
It implements IEEE 802.11 access point management, IEEE 802.1X/WPA/WPA2/EAP
Authenticators, RADIUS client, EAP server, and RADIUS authentication server.
The current version supports Linux (Host AP, madwifi, Prism54 drivers) and
FreeBSD (net80211).

hostapd is designed to be a "daemon" program that runs in the background and
acts as the backend component controlling authentication. hostapd supports
separate frontend programs and an example text-based frontend, hostapd_cli,
is included with hostapd.

%prep
%setup -q -n hostapd-%{_version}
%setup -q -D -T -a 1 -n hostapd-%{_version}
%setup -q -D -T -a 2 -n hostapd-%{_version}
%setup -q -D -T -a 3 -n hostapd-%{_version}
cd hostapd
%patch0 -p1 -b -kw.patch
cp defconfig .config
#sed -i -e 's|CONFIG_DRIVER_WIRED=y|#CONFIG_DRIVER_WIRED=y|' .config
#sed -i -e 's|CONFIG_IAPP=y|#CONFIG_IAPP=y|' .config
#sed -i -e 's|CONFIG_DRIVER_MADWIFI=y|#CONFIG_DRIVER_MADWIFI=y|' .config
sed -i -e 's|CONFIG_DRIVER_BSD=y|#CONFIG_DRIVER_BSD=y|' .config
#sed -i -e 's|CONFIG_DRIVER_DEVICESCAPE=y|#CONFIG_DRIVER_DEVICESCAPE=y|' .config
sed -i -e 's|#WIRELESS_DEV=/usr/src/wireless-dev|WIRELESS_DEV=mac80211-%{mac80211_version}|' .config
sed -i -e 's|#CFLAGS += -I$(WIRELESS_DEV)/net/mac80211|CFLAGS += -I$(WIRELESS_DEV)/origin/net/mac80211|' .config
sed -i -e 's|CONFIG_RADIUS_SERVER=y|#CONFIG_RADIUS_SERVER=y|' .config
#sed -i -e 's|# CFLAGS += -DUSE_KERNEL_HEADERS -I/usr/src/linux/include|CFLAGS += -DUSE_KERNEL_HEADERS -I%{_includedir}|' Makefile
## Dyn patch all CFGLAGS inside Makefile 
sed -i -e 's|# CFLAGS += -DUSE_KERNEL_HEADERS -I/usr/src/linux/include|CFLAGS +=-DUSE_KERNEL_HEADERS -I%{_includedir} -I../madwifi-%{madwifi_version} -I../mac80211-%{mac80211_version}/origin/include -I../mac80211-%{mac80211_version}/origin/net/mac80211 \nLIBS+=-L%{_libdir}|' Makefile
sed -i -e 's|typedef u64 __bitwise __be64;||' ../src/utils/common.h
sed -i -e 's|typedef u64 __bitwise __le64;||' ../src/utils/common.h
sed -i -e 's|/usr/local/bin/|$(DESTDIR)%{_bindir}/|' Makefile
install -m 0644 logwatch/README README.logwatch
# -I../src/radius

%build
export CFLAGS=$RPM_OPT_FLAGS
cd hostapd
make \
   DIR_WPA_SUPPLICANT=wpa_supplicant-%{wpa_supplicant_version} \
  %{?_smp_mflags}

## WIP
#   CFLAGS+="-Id80211-%{d80211_version}/compatible/include -Id80211-%{d80211_version}/compatible/net/d80211" \
#   CFLAGS+="-I%{_includedir} -DUSE_KERNEL_HEADERS" \
#   CFLAGS="$CFLAGS -Imadwifi-%{madwifi_version}" LIBS+="-L%{_libdir}" \
#   DIR_WPA_SUPPLICANT=wpa_supplicant-%{wpa_supplicant_version} \
#   DIR_WPA_SUPPLICANT=wpa_supplicant-git-%{date} \

%install
rm -rf $RPM_BUILD_ROOT
cd hostapd
mkdir -p $RPM_BUILD_ROOT%{_bindir}
make install DESTDIR=$RPM_BUILD_ROOT

mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/hostapd
install -m 0644 *.conf $RPM_BUILD_ROOT%{_sysconfdir}/hostapd
install -m 0644 hostapd.deny $RPM_BUILD_ROOT%{_sysconfdir}/hostapd
install -m 0644 hostapd.accept $RPM_BUILD_ROOT%{_sysconfdir}/hostapd
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/
install -m 0644 logwatch/hostapd.conf $RPM_BUILD_ROOT%{_sysconfdir}/log.d/conf/services/
mkdir -p $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/
install -m 0755 logwatch/hostapd $RPM_BUILD_ROOT%{_sysconfdir}/log.d/scripts/services/


%clean
rm -rf $RPM_BUILD_ROOT


%files
%defattr(-,root,root,-)
%doc hostapd/ChangeLog COPYING hostapd/developer.txt hostapd/README hostapd/README.logwatch
%doc hostapd/hostapd.deny hostapd/hostapd.accept hostapd/hostapd.conf
%config(noreplace) %{_sysconfdir}/log.d/conf/services/hostapd.conf
%config(noreplace) %{_sysconfdir}/hostapd/*
%{_sysconfdir}/log.d/scripts/services/hostapd
%{_bindir}/hostapd
%{_bindir}/hostapd_cli


%changelog
* Sat Mar 31 2007 kwizart < kwizart at gmail.com > - 0.6-0.5.20070325
- Update to snapshot 20070325
- Update to mac80211 6.0.0
- Disable madwifi (wip)

* Fri Mar 24 2007 kwizart < kwizart at gmail.com > - 0.6-0.4.20070224
- Update to git 20070324
- Update madwifi to 9.3
- Update mac80211 to 5.0.0

* Tue Feb 28 2007 kwizart < kwizart at gmail.com > - 0.6-0.3.20070224
- Preliminary testing version for fc7 t2 and FE inclusion.
- Still use intel d80211 version because missing headers - This may be not be used in the future

* Tue Feb 27 2007 kwizart < kwizart at gmail.com > - 0.6-0.2.20070224
- Update to 0.6 20070224
- Use tarball for external headers

* Fri Dec 29 2006 kwizart < kwizart at gmail.com > - 0.6-0.1.20061228
- Initial release

